/**
 * Created by A ciTy on 2019/2/23.
 */

"use strict";

//20190530
//------------------------------------------------------------------------------
// Rule Definition
//------------------------------------------------------------------------------

const fileNameRegExp = /^i18n\/index.js$/;

module.exports = {
    meta: {
        docs: {
            description: "no duplicate word in i18n config file",
            category: "Fill me in",
            recommended: false
        },
        fixable: null,  // or "code" or "whitespace"
        schema: [
            // fill in your schema
        ],
        messages: {
            duplicateName: "There is a duplicate value：'{{ name }}'.Please combine them."
        }
    },

    create: function (context) {

        // variables should be defined here

        //----------------------------------------------------------------------
        // Helpers
        //----------------------------------------------------------------------

        // any helper functions should go here or else delete this section

        //----------------------------------------------------------------------
        // Public
        //----------------------------------------------------------------------

        const fileNameArray = context.getFilename().split('\\');

        const fileName = fileNameArray.length && fileNameArray.length >= 1 ? fileNameArray[fileNameArray.length - 2] + '/' + fileNameArray[fileNameArray.length - 1] : '';

        if (!fileNameRegExp.test(fileName)) {
            return {};
        }

        return {

            // give me methods


            'ExportNamedDeclaration': (node) => {

                if (node.declaration.declarations && node.declaration.declarations[0]) {

                    let root = node.declaration.declarations[0].init;

                    let zhValuesArray = [];

                    root.properties.forEach(item => {

                        item.value.properties.forEach(property => {

                            if(property.value.value && property.key.name === 'zh'){
                                //console.log('zhValuesArray', zhValuesArray)
                                let a = 1;

                                if (zhValuesArray.indexOf(property.value.value) < 0) {

                                    zhValuesArray.push(property.value.value);

                                }

                                else{

                                    context.report({
                                        node,
                                        messageId: 'duplicateName',
                                        data: {
                                            name: property.value.value,
                                        }
                                    });

                                }

                            }

                        })

                    })

                }

            }


        };
    }
};
