/**
 * @fileoverview no className which contains 'mini-'
 * @author acity
 */
"use strict";

//------------------------------------------------------------------------------
// Rule Definition
//------------------------------------------------------------------------------


const checkClassName = (node, className, context) => {

    if (className.indexOf('mini-') >= 0) {

        context.report({
            node: node,
            messageId: 'illegalClassName'
        });

    }
};

module.exports = {
    meta: {
        docs: {
            description: "no className which contains 'mini-'",
            category: "Fill me in",
            recommended: false
        },
        fixable: null,  // or "code" or "whitespace"
        schema: [
            // fill in your schema
        ],
        messages: {
            illegalClassName: `no className which contains 'mini-'`
        }
    },

    create: function (context) {

        // variables should be defined here

        //----------------------------------------------------------------------
        // Helpers
        //----------------------------------------------------------------------

        // any helper functions should go here or else delete this section

        //----------------------------------------------------------------------
        // Public
        //----------------------------------------------------------------------

        return {

            // give me methods


            'JSXOpeningElement': node => {

                if (node.attributes && node.attributes.length) {

                    let classNameAttrs = node.attributes.filter(item => item.name && item.name.name && item.name.name === 'className');

                    if (classNameAttrs && classNameAttrs.length) {

                        classNameAttrs.forEach(attr => {

                            //有{}
                            if (attr.value && attr.value.expression && attr.value.expression.value) {
                                //console.log('classNameclassNameclassName', attr.value.expression.value)

                                checkClassName(node, attr.value.expression.value, context);

                            }

                            //没有{}，直接字符串
                            if (attr.value && attr.value.value && attr.value.value) {
                                //console.log('classNameclassNameclassName', attr.value.value)

                                checkClassName(node, attr.value.value, context);

                            }

                        })

                    }

                }


            }

        }


    }

};