/**
 * @fileoverview no custom variables exported in page config
 * @author acity
 */
"use strict";

//------------------------------------------------------------------------------
// Requirements
//------------------------------------------------------------------------------

var rule = require("../../../lib/rules/no-custom-page-config"),

    RuleTester = require("eslint").RuleTester;

const parserOptions = {
    "ecmaFeatures": {
        "jsx": true,
        "modules": true
    },
    "sourceType": "module",
    "ecmaVersion": 7
};


//------------------------------------------------------------------------------
// Tests
//------------------------------------------------------------------------------

var ruleTester = new RuleTester({parserOptions});
ruleTester.run("no-custom-page-config", rule, {

    valid: [
        {
            code: `
           
export const pageIdentifier = "systemWarnSetting";
export const reducerConfigList = [
    {
        name: 'isLoading',
        initialState: false
    }
];
   
            `,
            filename: "config.jsx"
        }

        // give me some code that won't trigger a warning
    ],

    invalid: [
        {
            code: `
            export const pluginEnum = {
    Tree: "tree",
    TreeRole: "TreeRole",
    Pagination: "Pagination"
};

export const editType = {
    adding: 1,
    editing: 2
};

            `,
            errors: [{
                messageId: "invalidName"
            }],
            filename: "config.jsx"
        }
    ]
});
